#include "main.h"
#include "user_init.h"
#include "bintohex.h"



/**
  ****************************************************************************************************
  * @file    main.c
  * @author  FMSH Application Team
  * @brief   Header file of  LL Module
  ****************************************************************************************************
  * @attention
  *
  * Copyright (c) [2019] [Fudan Microelectronics]
  * THIS SOFTWARE is licensed under the Mulan PSL v1.
  * can use this software according to the terms and conditions of the Mulan PSL v1.
  * You may obtain a copy of Mulan PSL v1 at:
  * http://license.coscl.org.cn/MulanPSL
  * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND, EITHER EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT, MERCHANTABILITY OR FIT FOR A PARTICULAR
  * PURPOSE.
  * See the Mulan PSL v1 for more details.
  *
  ****************************************************************************************************
  */
  
 
uint32_t time=0;

__attribute__((section("TORAM"))) void DataErase(uint32_t Space)                      
{                                                   

  RCC->PCLKCR2 |= BIT5;                            
  RCC->OPCCR2 |= BIT22;                             
   
  FLASH->EPCR = BIT0;                              
  FLASH->KEY = 0x96969696U;  
  FLASH->KEY = 0xEAEAEAEAU;   
  *((uint32_t *)Space) =  0x1234ABCDU;
  while(!(FLASH->ISR & BIT0));                      
  FLASH->ISR |= BIT0;                               
  FLASH->KEY = 0x00000000;                       

   RCC->OPCCR2  &= ~BIT22;                        
   RCC->PCLKCR2 &= ~BIT5;                         
}

void VTOR2RAM(void)
{
    __disable_irq();
    memcpy( (void*)0x20000000, (void*)0x00000000, 0xc0);
    SCB->VTOR = 0X20000000;   
    __enable_irq();
}

void TestLED(void)
{
    FL_GPIO_InitTypeDef GPIO_InitStruct = {0};
   
    FL_GPIO_ResetOutputPin(GPIOC, FL_GPIO_PIN_0);
    
    GPIO_InitStruct.pin = FL_GPIO_PIN_0;
    GPIO_InitStruct.mode = FL_GPIO_MODE_OUTPUT;
    GPIO_InitStruct.outputType = FL_GPIO_OUTPUT_PUSHPULL;
    GPIO_InitStruct.pull = FL_DISABLE;
    FL_GPIO_Init(GPIOC, &GPIO_InitStruct);

}

void Bstim_Init(void)
{
    FL_BSTIM32_InitTypeDef    defaultInitStruct;
    defaultInitStruct.prescaler = 199;
    defaultInitStruct.autoReload = 7;
    defaultInitStruct.autoReloadState = FL_ENABLE;
    defaultInitStruct.clockSource = FL_RCC_BSTIM32_CLK_SOURCE_APB2CLK;

    FL_BSTIM32_Init(BSTIM32,&defaultInitStruct );

    FL_BSTIM32_EnableIT_Update(BSTIM32 );
    NVIC_DisableIRQ(BSTIM_IRQn);
    NVIC_SetPriority(BSTIM_IRQn, 2);
    NVIC_EnableIRQ(BSTIM_IRQn);
    
    FL_BSTIM32_Enable(BSTIM32);
}

int main(void)
{
    VTOR2RAM(); //жض
   
    TestLED(); //GPIOC.0ָʾ

    Bstim_Init();   //BSTIM-200uSж
    
    while(1)
    {

        DataErase(0X3F800);
        __nop();
    }

}

__attribute__((section("TORAM"))) void BSTIM_IRQHandler()
{
    time++;
    BSTIM32->ISR = 0X01;
    if(GPIOC->DO & 0X01)
        GPIOC->DRST =0X01;
    else
        GPIOC->DSET =0X01;        

}
